"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});
/**
* An instruction is meant to contain all the information that the other endpoint needs to execute code.
* In RPC, this information consists of a command name and the instructions for that command.
*/
class Instruction {
	constructor(command, ...args) {
		this.command = command;
		this.args = args;
		this.type = this.constructor.type;
		/* Substitute Error instances */
		for (let i = 0; i < args.length; ++i) {
			const arg = args[i];
			if (arg instanceof Error) {
				args[i] = {
					error: true,
					message: arg.message,
					stack: arg.stack
				};
			}
		}
	}
}
class SYN extends Instruction {}
exports.SYN = SYN;
SYN.type = 0;
class ACK extends Instruction {}
exports.ACK = ACK;
ACK.type = 1;
class SYN_ACK extends Instruction {}
exports.SYN_ACK = SYN_ACK;
SYN_ACK.type = 2;