"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _asyncToGenerator2 = require("babel-runtime/helpers/asyncToGenerator");

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _Message = require("./Message");

var _Message2 = _interopRequireDefault(_Message);

var _RemoteError = require("./RemoteError");

var _RemoteError2 = _interopRequireDefault(_RemoteError);

var _Protocol = require("./Protocol");

var _util = require("util");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = (around, {
	encode,
	decode,
	bind = false
} = {}) => new Proxy(around, {
	get: (target, property, receiver) => {
		if (property === "inspect" || property === _util.inspect.custom) {
			return () => {
				/* The proxy should at least be printable */
				return target;
			};
		}
		if (property === "then") {
			return receiver;
		}
		const lookUp = target[property];
		if (!lookUp) {
			return (() => {
				var _ref = (0, _asyncToGenerator3.default)(function* (...args) {
					const remoteLookUp = new _Message2.default(new _Protocol.SYN(property, ...args), {
						encode,
						decode
					});
					const [message, result] = yield target.send(remoteLookUp);
					message.reply();
					if (result && result.error && result.message && result.stack) {
						throw new _RemoteError2.default(result.message, result.stack);
					} else {
						return result;
					}
				});

				return function () {
					return _ref.apply(this, arguments);
				};
			})();
		} else {
			if (bind && lookUp instanceof Function) {
				return lookUp.bind(target);
			} else {
				return lookUp;
			}
		}
	}
});